# Copyright 2015, 2018 Kevin Ryde

# This file is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as published
# by the Free Software Foundation; either version 3, or (at your option) any
# later version.
#
# This file is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
# Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.

use strict;
use IPC::Run;

# uncomment this to run the ### lines
use Smart::Comments;

# my $ret = IPC::Run::run(['sh','-c','exit','1']);
# ### $ret
# ### $?

my $ret = IPC::Run::run(['/usr/bin/gp',
                         '-f',
                         '--default','recover=0',
                        # 'gp-inline-devel.gp'
                         '/tmp/c.gp'
                        ],
                        '<', '/dev/null',
                        '>',\my $stdout,
                        '2>',\my $stderr);
my $wait_status = $?;
my $wifexited = POSIX::WIFEXITED($wait_status);
my $wexitstatus = POSIX::WEXITSTATUS($wait_status);
print $stdout;
print $stderr;
### $ret
### $wait_status
### $wifexited;
### $wexitstatus




#------------------------------------------------------------------------------
# Unused bit running tests by a wrapper doing read("temp.gp") of actual
# tests.

# my $runner_tempfh;
  # eval { $runner_tempfh->DESTROY; };

    #     $runner_tempfh = File::Temp->new (TEMPLATE => 'gp-inline-XXXXXX',
    #                                       SUFFIX   => '.gp',
    #                                       TMPDIR   => 1);
    #
    #     my $read_filename = gp_quote($output_fh->filename);
    #     print $runner_tempfh <<"HERE";
    # {
    #   read($read_filename);
    # }
    # HERE
    #   iferr(read($read_filename),err,
    #         print("rethrow");
    #         error(err), /* rethrow */
    #         0);
    # /* print(gp_inline__location,"error reading"); 0 */

# Return $str as a string "$str" for use in a gp script.
# Any " quotes etc in $str are suitably escaped.
sub gp_quote {
  my ($str) = @_;
  $str =~ s/\"/\\"/g;
  return '"'.$str.'"';
}

